;NSIS Setup Script
;--------------------------------

!ifndef VERSION
  !define VERSION '2.2.8.32'
!endif

;--------------------------------
;Configuration

!ifdef OUTFILE
  OutFile "${OUTFILE}"
!else
  OutFile Notepad-${VERSION}-setup.exe
!endif

;SetCompressor /SOLID lzma

InstType "Full"
InstType "Lite"
InstType "Minimal"

InstallDir "$PROGRAMFILES\Notepad GNU"
InstallDirRegKey HKLM "Software\Notepad GNU" ""

RequestExecutionLevel admin

;--------------------------------
;Header Files

!include "MUI2.nsh"
!include "Sections.nsh"
!include "LogicLib.nsh"
!include "Memento.nsh"
!include "WordFunc.nsh"
!include "x64.nsh"
;!include "Colors.nsh"
;!include "WordFunc.nsh"

;--------------------------------
;Functions

!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD

  !insertmacro VersionCompare

!endif

;--------------------------------
;Definitions

!define SHCNE_ASSOCCHANGED 0x8000000
!define SHCNF_IDLIST 0

;--------------------------------
;Configuration

;Names
Name "Notepad GNU"
Caption "Notepad GNU ${VERSION} Setup"

;Memento Settings
!define MEMENTO_REGISTRY_ROOT HKLM
!define MEMENTO_REGISTRY_KEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU"

;Interface Settings
!define MUI_ABORTWARNING
!define MUI_ICON "${NSISDIR}\Contrib\Graphics\Icons\orange-install.ico"
!define MUI_UNICON "${NSISDIR}\Contrib\Graphics\Icons\orange-uninstall.ico"
!define MUI_HEADERIMAGE
!define MUI_WELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\Notepad.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Wizard\Notepad.bmp"
!define MUI_UNWELCOMEFINISHPAGE_BITMAP_NOSTRETCH 
!define MUI_HEADERIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Header\orange.bmp" ; optional
!define MUI_ABORTWARNING"${NSISDIR}\Contrib\Graphics\Checks\simple-round2.bmp" ; optional
!define MUI_UNISTALL_BITMAP"${NSISDIR}\Contrib\Graphics\Wizard\Notepad.bmp"

;CheckBitmap "${NSISDIR}\Contrib\Graphics\Checks\classic-cross.bmp"
!define MUI_COMPONENTSPAGE_SMALLDESC 

!define MUI_LICENSEPAGE_CHECKBOX
!define MUI_CHECKIMAGE_BITMAP "${NSISDIR}\Contrib\Graphics\Checks\classic-cross.bmp"
!define MUI_LICENSEPAGE_RADIOBUTTONS

;   ().
    SetDatablockOptimize on
;    .
    InstallDir "$PROGRAMFILES\Notepad GNU"
;/      (hide-, show-, nevershow-  ). 
    ShowInstDetails show
    ShowUninstDetails show
; XP manifest    XP  (on  off).  
    XPStyle on
;    (  Nullsoft Install System v2.06).   
;  Var BRANDING_TEXT .       (/TRIMLEFT()/
;TRIMRIGHT()/TRIMCENTER( )).
    BrandingText /TRIMLEFT "GNUlius open lab"

;    .  
    VIAddVersionKey  "ProductName" "Notepad GNU"
    VIAddVersionKey  "Comments" "Notepad GNU"
    VIAddVersionKey  "CompanyName" "GNUlius open lab"
    VIAddVersionKey  "LegalTrademarks" "Notepad GNU    GNUlius open lab"
    VIAddVersionKey  "LegalCopyright" " GNUlius open lab"
    VIAddVersionKey  "FileDescription" "Notepad GNU"
    VIAddVersionKey  "FileVersion" "2.2.8.32"
    VIProductVersion "2.2.8.32"

;Pages
!define MUI_WELCOMEPAGE_TITLE "    Notepad GNU ${VERSION}"
!define MUI_WELCOMEPAGE_TEXT "    Notepad GNU ${VERSION}.$\r$\n$\r$\n$_CLICK"

!insertmacro MUI_PAGE_WELCOME
!insertmacro MUI_PAGE_LICENSE "C:\Program Files\Notepad GNU\License.txt"
!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
Page custom PageReinstall PageLeaveReinstall
!endif
!insertmacro MUI_PAGE_COMPONENTS
!insertmacro MUI_PAGE_DIRECTORY
!insertmacro MUI_PAGE_INSTFILES

!define MUI_FINISHPAGE_LINK_LOCATION "http://viacoding.ucoz.ru/load/30-1-0-157"
!define MUI_FINISHPAGE_LINK "     "

!define MUI_FINISHPAGE_RUN "$INSTDIR\Notepad GNU.exe"
!define MUI_FINISHPAGE_NOREBOOTSUPPORT

;!define MUI_FINISHPAGE_SHOWREADME
;!define MUI_FINISHPAGE_SHOWREADME_TEXT "Show release notes"
;!define MUI_FINISHPAGE_SHOWREADME_FUNCTION ShowReleaseNotes

!insertmacro MUI_PAGE_FINISH

;--------------------------------
; 

; .
    !insertmacro MUI_UNPAGE_WELCOME
;  .
    !insertmacro MUI_UNPAGE_CONFIRM
; .
    ;!insertmacro MUI_UNPAGE_LICENSE "      *.rtf  *.txt"
;    .
    ;!insertmacro MUI_UNPAGE_COMPONENTS
;    .
;    !insertmacro MUI_UNPAGE_DIRECTORY
;  .
    !insertmacro MUI_UNPAGE_INSTFILES
; .
    !insertmacro MUI_UNPAGE_FINISH

;--------------------------------
;Languages

!insertmacro MUI_LANGUAGE "Russian"
!insertmacro MUI_LANGUAGE "English" ;first language is the default language
!insertmacro MUI_LANGUAGE "French"
!insertmacro MUI_LANGUAGE "German"
!insertmacro MUI_LANGUAGE "Spanish"
!insertmacro MUI_LANGUAGE "SpanishInternational"
!insertmacro MUI_LANGUAGE "SimpChinese"
!insertmacro MUI_LANGUAGE "TradChinese"
!insertmacro MUI_LANGUAGE "Japanese"
!insertmacro MUI_LANGUAGE "Korean"
!insertmacro MUI_LANGUAGE "Italian"
!insertmacro MUI_LANGUAGE "Dutch"
!insertmacro MUI_LANGUAGE "Danish"
!insertmacro MUI_LANGUAGE "Swedish"
!insertmacro MUI_LANGUAGE "Norwegian"
!insertmacro MUI_LANGUAGE "NorwegianNynorsk"
!insertmacro MUI_LANGUAGE "Finnish"
!insertmacro MUI_LANGUAGE "Greek"
!insertmacro MUI_LANGUAGE "Portuguese"
!insertmacro MUI_LANGUAGE "PortugueseBR"
!insertmacro MUI_LANGUAGE "Polish"
!insertmacro MUI_LANGUAGE "Ukrainian"
!insertmacro MUI_LANGUAGE "Czech"
!insertmacro MUI_LANGUAGE "Slovak"
!insertmacro MUI_LANGUAGE "Croatian"
!insertmacro MUI_LANGUAGE "Bulgarian"
!insertmacro MUI_LANGUAGE "Hungarian"
!insertmacro MUI_LANGUAGE "Thai"
!insertmacro MUI_LANGUAGE "Romanian"
!insertmacro MUI_LANGUAGE "Latvian"
!insertmacro MUI_LANGUAGE "Macedonian"
!insertmacro MUI_LANGUAGE "Estonian"
!insertmacro MUI_LANGUAGE "Turkish"
!insertmacro MUI_LANGUAGE "Lithuanian"
!insertmacro MUI_LANGUAGE "Slovenian"
!insertmacro MUI_LANGUAGE "Serbian"
!insertmacro MUI_LANGUAGE "SerbianLatin"
!insertmacro MUI_LANGUAGE "Arabic"
!insertmacro MUI_LANGUAGE "Farsi"
!insertmacro MUI_LANGUAGE "Hebrew"
!insertmacro MUI_LANGUAGE "Indonesian"
!insertmacro MUI_LANGUAGE "Mongolian"
!insertmacro MUI_LANGUAGE "Luxembourgish"
!insertmacro MUI_LANGUAGE "Albanian"
!insertmacro MUI_LANGUAGE "Breton"
!insertmacro MUI_LANGUAGE "Belarusian"
!insertmacro MUI_LANGUAGE "Icelandic"
!insertmacro MUI_LANGUAGE "Malay"
!insertmacro MUI_LANGUAGE "Bosnian"
!insertmacro MUI_LANGUAGE "Kurdish"
!insertmacro MUI_LANGUAGE "Irish"
!insertmacro MUI_LANGUAGE "Uzbek"
!insertmacro MUI_LANGUAGE "Galician"
!insertmacro MUI_LANGUAGE "Afrikaans"
!insertmacro MUI_LANGUAGE "Catalan"
!insertmacro MUI_LANGUAGE "Esperanto"

!insertmacro MUI_RESERVEFILE_LANGDLL

;--------------------------------
;Installer Sections

${MementoSection} "Notepad GNU" SecNotepad

  SetDetailsPrint textonly
  DetailPrint "  Notepad GNU..."
  SetDetailsPrint listonly

  SectionIn 1 2 3 RO
  SetOutPath $INSTDIR
    File "C:\Program Files\Notepad GNU\License.txt"
    File "C:\Program Files\Notepad GNU\Notepad GNU.exe"
    File "C:\Program Files\Notepad GNU\ReadMe (Rus).txt"
    File "C:\Program Files\Notepad GNU\ReadMe (Eng).txt"

  SetOutPath "$INSTDIR\localization\"
    File "C:\Program Files\Notepad GNU\localization\english.lng"
    File "C:\Program Files\Notepad GNU\localization\russian.lng"
    File "C:\Program Files\Notepad GNU\localization\ukrainian.lng"
    File "C:\Program Files\Notepad GNU\localization\chinese.lng"

 ; RMDir /r "C:\Program Files\Notepad"

;File "C:\Program Files\OllyDBG\"  
  SetOverwrite on

 ; File /nonfatal ..\NSIS.exe.manifest

;  IfFileExists $INSTDIR\nsisconf.nsi "" +2
;  Rename $INSTDIR\nsisconf.nsi $INSTDIR\OllyDBGsconf.nsh
;  SetOverwrite off
;  File ..\OllyDBGsconf.nsh
;  SetOverwrite on
    
; ReadRegStr $R0 HKLM "Applications\OllyDbg.EXE\shell\OllyDbg\command" ""
;  StrCmp $R0 "NSISFile" 0 +2
;    DeleteRegKey HKCR "NSISFile"	
 ${MementoSectionEnd}
;
${MementoSection} "   " SecDesktop

  SetDetailsPrint textonly
  DetailPrint "    "
  SetDetailsPrint listonly

  SectionIn 1 2
  CreateShortCut "$DESKTOP\Notepad GNU.lnk" "$INSTDIR\Notepad GNU.exe"  
${MementoSectionEnd}

${MementoSection} "  " SecSMPrograms

  SetDetailsPrint textonly
  DetailPrint "   "
  SetDetailsPrint listonly

  SectionIn 1 2
    CreateDirectory "$SMPROGRAMS\$R0Notepad GNU\"
    CreateShortCut "$SMPROGRAMS\Notepad GNU\Notepad GNU.lnk" "$INSTDIR\Notepad GNU.exe"
    CreateShortCut "$SMPROGRAMS\Notepad GNU\ReadMe.lnk" "$INSTDIR\ReadMe.txt"
	CreateShortCut "$SMPROGRAMS\Notepad GNU\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
  ;  CreateShortCut "$STARTMENU\Notepad GNU.lnk" "$INSTDIR\Notepad GNU.exe"
;  CreateShortCut "$STARTMENU\Uninstall.lnk" "$INSTDIR\Uninstall.exe"
;    CreateDirectory "$SMPROGRAMS\$R0"
;    CreateShortCut "$SMPROGRAMS\$R0\Notepad GNU.lnk" "$INSTDIR\Notepad GNU.exe"
;    CreateShortCut "$SMPROGRAMS\$R0\ReadMe.lnk" "$INSTDIR\ReadMe.txt"  
${MementoSectionEnd}

${MementoSection} "    " SecQuickLaunch

  SetDetailsPrint textonly
  DetailPrint "     "
  SetDetailsPrint listonly

  SectionIn 1 2
  CreateShortCut "$QUICKLAUNCH\Notepad GNU.lnk" "$INSTDIR\Notepad GNU.exe"
${MementoSectionEnd}
${MementoSectionDone}

;
Section -post

  ; When Modern UI is installed:
  ; * Always install the English language file
  ; * Always install default icons / bitmaps

  ;!insertmacro SectionFlagIsSet ${SecInterfacesModernUI} ${SF_SELECTED} mui nomui

  ;  mui:

  ;  SetDetailsPrint textonly
  ;  DetailPrint "Configuring Modern UI..."
  ;  SetDetailsPrint listonly

 ;   !insertmacro SectionFlagIsSet ${SecLangFiles} ${SF_SELECTED} langfiles nolangfiles

   ;   nolangfiles:

    ;  SetOutPath "$INSTDIR\Contrib\Language files"
    ;  File "..\Contrib\Language files\English.nlf"
    ;  SetOutPath "$INSTDIR\Contrib\Language files"
    ;  File "..\Contrib\Language files\English.nsh"

   ; langfiles:

  ;  !insertmacro SectionFlagIsSet ${SecGraphics} ${SF_SELECTED} graphics nographics

   ;   nographics:

    ;  SetOutPath $INSTDIR\Contrib\Graphics
    ;  SetOutPath $INSTDIR\Contrib\Graphics\Checks
    ;  File "..\Contrib\Graphics\Checks\simple-round.bmp"
    ;  SetOutPath $INSTDIR\Contrib\Graphics\Icons
    ;  File "..\Contrib\Graphics\Icons\llama-blue.ico"
    ;  File "..\Contrib\Graphics\Icons\orange-uninstall.ico"
    ;  SetOutPath $INSTDIR\Contrib\Graphics\Header
    ;  File "..\Contrib\Graphics\Header\orange.bmp"
    ;  SetOutPath $INSTDIR\Contrib\Graphics\Wizard
    ;  File "..\Contrib\Graphics\Wizard\orange.bmp"

  ; graphics:

 ; nomui:

 ; SetDetailsPrint textonly
 ; DetailPrint "Creating Registry Keys..."
 ; SetDetailsPrint listonly

 ; SetOutPath $INSTDIR

 ;    WriteRegStr HKCR "Applications\OllyDbg.EXE\shell\OllyDbg\command" "" '"$INSTDIR\OllyDbg.EXE \"%1\"' 
  WriteRegStr HKCR "*\shell\Notepad GNU\command" "" '$INSTDIR\Notepad GNU.exe "%1"' 
  WriteRegStr HKLM "Software\Notepad GNU" "" $INSTDIR
!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
  WriteRegDword HKLM "Software\Notepad GNU" "VersionMajor" "${VER_MAJOR}"
  WriteRegDword HKLM "Software\Notepad GNU" "VersionMinor" "${VER_MINOR}"
  WriteRegDword HKLM "Software\Notepad GNU" "VersionRevision" "${VER_REVISION}"
  WriteRegDword HKLM "Software\Notepad GNU" "VersionBuild" "${VER_BUILD}"
!endif

  WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "UninstallString" '"$INSTDIR\uninst-Notepad.exe"'
  WriteRegExpandStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "InstallLocation" "$INSTDIR"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "DisplayName" "Nullsoft Install System"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "DisplayIcon" "$INSTDIR\NSIS.exe,0"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "DisplayVersion" "${VERSION}"
!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "VersionMajor" "${VER_MAJOR}"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "VersionMinor" "${VER_MINOR}.${VER_REVISION}"
!endif
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "URLInfoAbout" "http://viacoding.ucoz.ru/load/30-1-0-157"
  WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "HelpLink" "http://viacoding.ucoz.ru/load/30-1-0-157"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "NoModify" "0"
  WriteRegDWORD HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU" "NoRepair" "0"

  WriteUninstaller "$INSTDIR\Uninstall.exe"

  ${MementoSectionSave}

  SetDetailsPrint both

SectionEnd

;--------------------------------
;Descriptions

!insertmacro MUI_FUNCTION_DESCRIPTION_BEGIN
  !insertmacro MUI_DESCRIPTION_TEXT ${SecNotepad} "   Notepad GNU"
  !insertmacro MUI_DESCRIPTION_TEXT ${SecDesktop} "    "
  !insertmacro MUI_DESCRIPTION_TEXT ${SecQuickLaunch} "     "
  !insertmacro MUI_DESCRIPTION_TEXT ${SecSMPrograms} "   "
!insertmacro MUI_FUNCTION_DESCRIPTION_END

;--------------------------------
;Installer Functions

Function .onInit
!insertmacro MUI_LANGDLL_DISPLAY

  ${MementoSectionRestore}

FunctionEnd

!ifdef VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD

Var ReinstallPageCheck

Function PageReinstall

  ReadRegStr $R0 HKLM "Software\Notepad GNU" ""

  ${If} $R0 == ""
    Abort
  ${EndIf}

  ReadRegDWORD $R0 HKLM "Software\Notepad GNU" "VersionMajor"
  ReadRegDWORD $R1 HKLM "Software\Notepad GNU" "VersionMinor"
  ReadRegDWORD $R2 HKLM "Software\Notepad GNU" "VersionRevision"
  ReadRegDWORD $R3 HKLM "Software\Notepad GNU" "VersionBuild"
  StrCpy $R0 $R0.$R1.$R2.$R3

  ${VersionCompare} ${VER_MAJOR}.${VER_MINOR}.${VER_REVISION}.${VER_BUILD} $R0 $R0
  ${If} $R0 == 0
    StrCpy $R1 "NSIS ${VERSION} is already installed. Select the operation you want to perform and click Next to continue."
    StrCpy $R2 "Add/Reinstall components"
    StrCpy $R3 "Uninstall NSIS"
    !insertmacro MUI_HEADER_TEXT "Already Installed" "Choose the maintenance option to perform."
    StrCpy $R0 "2"
  ${ElseIf} $R0 == 1
    StrCpy $R1 "An older version of NSIS is installed on your system. It's recommended that you uninstall the current version before installing. Select the operation you want to perform and click Next to continue."
    StrCpy $R2 "Uninstall before installing"
    StrCpy $R3 "Do not uninstall"
    !insertmacro MUI_HEADER_TEXT "Already Installed" "Choose how you want to install NSIS."
    StrCpy $R0 "1"
  ${ElseIf} $R0 == 2
    StrCpy $R1 "A newer version of NSIS is already installed! It is not recommended that you install an older version. If you really want to install this older version, it's better to uninstall the current version first. Select the operation you want to perform and click Next to continue."
    StrCpy $R2 "Uninstall before installing"
    StrCpy $R3 "Do not uninstall"
    !insertmacro MUI_HEADER_TEXT "Already Installed" "Choose how you want to install NSIS."
    StrCpy $R0 "1"
  ${Else}
    Abort
  ${EndIf}

  nsDialogs::Create /NOUNLOAD 1018

  ${NSD_CreateLabel} 0 0 100% 24u $R1
  Pop $R1

  ${NSD_CreateRadioButton} 30u 50u -30u 8u $R2
  Pop $R2
  ${NSD_OnClick} $R2 PageReinstallUpdateSelection

  ${NSD_CreateRadioButton} 30u 70u -30u 8u $R3
  Pop $R3
  ${NSD_OnClick} $R3 PageReinstallUpdateSelection

  ${If} $ReinstallPageCheck != 2
    SendMessage $R2 ${BM_SETCHECK} ${BST_CHECKED} 0
  ${Else}
    SendMessage $R3 ${BM_SETCHECK} ${BST_CHECKED} 0
  ${EndIf}

  nsDialogs::Show

FunctionEnd

Function PageReinstallUpdateSelection

  Pop $R1

  ${NSD_GetState} $R2 $R1

  ${If} $R1 == ${BST_CHECKED}
    StrCpy $ReinstallPageCheck 1
  ${Else}
    StrCpy $ReinstallPageCheck 2
  ${EndIf}

FunctionEnd

Function PageLeaveReinstall

  ${NSD_GetState} $R2 $R1

  StrCmp $R0 "1" 0 +2
    StrCmp $R1 "1" reinst_uninstall reinst_done

  StrCmp $R0 "2" 0 +3
    StrCmp $R1 "1" reinst_done reinst_uninstall

  reinst_uninstall:
  ReadRegStr $R1 HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\NSIS" "UninstallString"

  ;Run uninstaller
  HideWindow

    ClearErrors
    ExecWait '$R1 _?=$INSTDIR'

    IfErrors no_remove_uninstaller
    IfFileExists "$INSTDIR\makensis.exe" no_remove_uninstaller

      Delete $R1
      RMDir $INSTDIR

    no_remove_uninstaller:

  StrCmp $R0 "2" 0 +2
    Quit

  BringToFront

  reinst_done:

FunctionEnd

!endif # VER_MAJOR & VER_MINOR & VER_REVISION & VER_BUILD

;Function ShowReleaseNotes
;  ${If} ${FileExists} $WINDIR\hh.exe
;    StrCpy $0 $WINDIR\OLLYDBG.hlp
;    Exec '"$0"$INSTDIR\Help\OLLYDBG.hlp'
;  ${Else}
;    SearchPath $0 hh.exe
;    ${If} ${FileExists} $0
;      Exec '"$0"$INSTDIR\Help\OLLYDBG.hlp'
;    ${Else}
;      ExecShell "open" "www.ollydbg.de"
;    ${EndIf}
;  ${EndIf}
;FunctionEnd

;--------------------------------
;Uninstaller Section

Section Uninstall

  SetDetailsPrint textonly
  DetailPrint "Uninstalling Notepad GNU Development Shell Extensions..."
  SetDetailsPrint listonly

 ; IfFileExists $INSTDIR\makensis.exe nsis_installed
 ;   MessageBox MB_YESNO "It does not appear that Notepad is installed in the directory '$INSTDIR'.$\r$\nContinue anyway (not recommended)?" IDYES nsis_installed
 ;   Abort "Uninstall aborted by user"
 ; nsis_installed:

  SetDetailsPrint textonly
  DetailPrint "Deleting Registry Keys..."
  SetDetailsPrint listonly

  System::Call 'Shell32::SHChangeNotify(i ${SHCNE_ASSOCCHANGED}, i ${SHCNF_IDLIST}, i 0, i 0)'

;  DeleteRegKey HKCR "Applications\Notepad GNU.EXE"
  DeleteRegKey HKLM "Software\Microsoft\Windows\CurrentVersion\Uninstall\Notepad GNU"
  DeleteRegKey HKLM "Software\Notepad GNU"
  DeleteRegKey HKCR "*\shell\Notepad GNU" 

  SetDetailsPrint textonly
  DetailPrint "Deleting Files..."
  SetDetailsPrint listonly

  	Delete "$STARTMENU\Notepad GNU.lnk"
	Delete "$DESKTOP\Notepad GNU.lnk"
	Delete "$QUICKLAUNCH\Notepad GNU.lnk"
	RMDir "$SMPROGRAMS\Notepad GNU"
;     .
    ;RMDir /r "$INSTDIR\MyFiles"
;    .
    ;Delete "$INSTDIR\*.*"
;     .    
    RMDir /r "$INSTDIR\*.*"
;  .    
    RMDir "$INSTDIR"
	RMDir /r "$SMPROGRAMS\Notepad GNU"

  SetDetailsPrint both

SectionEnd

; .EXE  .    ,     .
    !packhdr temp.dat '"C:\Program Files\NSIS\SWizard\Packers\upx" --best -q temp.dat'